#include <amxmodx>
#include <amxmisc>
#include <regex>
#include <fakemeta> // Закомментируйте или удалите, если не хотите использовать модуль fakemeta.


#define PLUGIN			"Yet Another SpamGuard"
#define VERSION			"1.2"
#define AUTHOR			"AndrewZ/voed"


#if defined _fakemeta_included
	#define OFFSET_CSMENUCODE	205
#endif


#define MAX_WLMESSAGES		128
#define MAX_WLNAMES			128
#define MAX_MESSAGES		128
#define MAX_NAMES			128
#define MAX_LONGMESSAGES	10
#define MAX_NAMECHANGES		4


#if AMXX_VERSION_NUM < 183
new g_regex_pattern[] = "^^[\w\d\-\'\<\>\{\}\[\]\(\)\*\.\\\?\$\|\/\,\:\;\~\`\@\#\!\&\=\^^\ ]+$"

new g_cyrillic[][] = {	"Й","Ц","У","К","Е","Н","Г","Ш","Щ","З","Х","Ъ","Ф","Ы","В","А","П","Р","О","Л","Д","Ж","Э","Я",
						"Ч","С","М","И","Т","Ь","Б","Ю","Ю","й","ц","у","к","е","н","г","ш","щ","з","х","ъ","ф","ы","в",
						"а","п","р","о","л","д","ж","э","я","ч","с","м","и","т","ь","б","ю","Ё","ё","і","І","Є","є","Ї","ї" }
#else
new g_regex_pattern[] = "^^[\w\dа-яА-Я\-\'\<\>\{\}\[\]\(\)\*\.\\\?\$\|\/\,\:\;\~\`\@\#\!\&\=\^^\ \і\І\ї\Ї\є\Є\Ё\ё]+$"
#endif

new WHITELIST_MESSAGES[ MAX_WLMESSAGES ][ 190 ],
	WHITELIST_NAMES[ MAX_WLNAMES ][ 32 ],
	BLOCKED_MESSAGES[ MAX_MESSAGES ][ 190 ],
	BLOCKED_NAMES[ MAX_NAMES ][ 32 ]

new bool:g_chatguard_key_used[ 33 ],
	bool:g_nameguard_key_used[ 33 ]
	
new g_spam_messages[ 33 ][ MAX_LONGMESSAGES ][ 190 ], 
	g_longmessages_count[ 33 ], 
	g_nameguard_menu_displayed[ 33 ],
	g_nameguard_name_changes[ 33 ]

new cvar_immunity_flag,
	cvar_chatguard_mode, cvar_chatguard_repeat_mode, cvar_chatguard_repeat_len,
	cvar_nameguard_mode, cvar_nameguard_name, cvar_nameguard_namespam
	
new g_msg_saytext

new g_maxplayers

new bool:g_setclientkeyvalue_block

new g_configs_dir[ 64 ]

public plugin_init()
{
	register_plugin( PLUGIN, VERSION, AUTHOR )
	
	register_logevent( "event_round_start", 2, "1=Round_Start" )
	
	register_forward( FM_SetClientKeyValue, "fwd_setclientkeyvalue" )
	
	register_clcmd( "say", "hook_say" )
	register_clcmd( "say_team", "hook_say" )
	
	g_msg_saytext = get_user_msgid( "SayText" )
	
	g_maxplayers = get_maxplayers()
	
	cvar_immunity_flag			= register_cvar( "yasg_immunity_flag", "a" )
	cvar_chatguard_mode			= register_cvar( "yasg_chatguard_mode", "2" )
	cvar_chatguard_repeat_mode	= register_cvar( "yasg_chatguard_repeat_mode", "2" )
	cvar_chatguard_repeat_len	= register_cvar( "yasg_chatguard_repeat_len", "13" )
	cvar_nameguard_mode			= register_cvar( "yasg_nameguard_mode", "2" )
	cvar_nameguard_name			= register_cvar( "yasg_nameguard_name", "[YASG] Player" )
	cvar_nameguard_namespam		= register_cvar( "yasg_nameguard_namespam", "1" )
	
	register_cvar( "yasg_version", VERSION, FCVAR_SPONLY | FCVAR_SERVER )
	set_cvar_string( "yasg_version", VERSION )
	
	register_dictionary( "yet_another_spamguard.txt" )

	register_menu( "chatguard_menu", -1, "handler_chatguard_menu" )
	register_menu( "nameguard_menu", -1, "handler_nameguard_menu" )

	set_task( 1.0, "task_read_files" )
}

public plugin_cfg()
{
	get_configsdir( g_configs_dir, charsmax( g_configs_dir ) )
	server_cmd( "exec %s/yet_another_spamguard/yasg_config.cfg", g_configs_dir )
}

public task_read_files()
{
	static temp[ 128 ], line, textsize, i
	
	line = 0
	i = 0
	formatex( temp, charsmax( temp ), "%s/yet_another_spamguard/yasg_whitelist_messages.ini", g_configs_dir )
	if( file_exists( temp ) )
	{
		static text[ 128 ]
		while( read_file( temp, line, text, charsmax( text ), textsize ) )
		{
			WHITELIST_MESSAGES[ i ++ ] = text
			line ++
		}
	}
	
	line = 0
	i = 0
	formatex( temp, charsmax( temp ), "%s/yet_another_spamguard/yasg_whitelist_names.ini", g_configs_dir )
	if( file_exists( temp ) )
	{
		static text[ 32 ]
		while( read_file( temp, line, text, charsmax( text ), textsize ) )
		{
			WHITELIST_NAMES[ i ++ ] = text
			line ++
		}
	}
	
	line = 0
	i = 0
	formatex( temp, charsmax( temp ), "%s/yet_another_spamguard/yasg_messages.ini", g_configs_dir )
	if( file_exists( temp ) )
	{
		static text[ 128 ]
		while( read_file( temp, line, text, charsmax( text ), textsize ) )
		{
			BLOCKED_MESSAGES[ i ++ ] = text
			line ++
		}
	}
	
	line = 0
	i = 0
	formatex( temp, charsmax( temp ), "%s/yet_another_spamguard/yasg_names.ini", g_configs_dir )
	if( file_exists( temp ) )
	{
		static text[ 32 ]
		while( read_file( temp, line, text, charsmax( text ), textsize ) )
		{
			BLOCKED_NAMES[ i ++ ] = text
			line ++
		}
	}
}

public event_round_start()
{
	if( !get_pcvar_num( cvar_nameguard_mode ) && !get_pcvar_num( cvar_nameguard_namespam ) )
		return
	
	static i
	
	for( i = 1; i <= g_maxplayers; i ++ )
	{
		g_nameguard_name_changes[ i ] = 0
		
		if( !g_nameguard_menu_displayed[ i ] )
			continue
			
		if( task_exists( i ) )
			remove_task( i )
			
		set_task( 1.0, "nameguard_check", i )
	}
}

public fwd_setclientkeyvalue( id, const infobuffer[], const key[], const value[] )
{
	if( g_setclientkeyvalue_block )
	{
		g_setclientkeyvalue_block = false
		return FMRES_IGNORED
	}
		
	if( !is_user_connected( id ) )
		return FMRES_IGNORED
		
	if( !equal( key, "name" ) )
		return FMRES_IGNORED
	
	if( get_pcvar_num( cvar_nameguard_mode ) )
	{
		if( task_exists( id ) )
			remove_task( id )
			
		set_task( 1.0, "nameguard_check", id )
	}
		
	if( get_pcvar_num( cvar_nameguard_namespam ) && I_can_do_something( id ) )
	{	
		g_nameguard_name_changes[ id ] ++
		
		if( g_nameguard_name_changes[ id ] > MAX_NAMECHANGES )
			kick_user( id, "YASG_KICK_NAMEGUARD_NAMESPAM" )
	}
	
	return FMRES_IGNORED
}

public client_putinserver( id )
{
	g_nameguard_key_used[ id ] 		 = false
	g_chatguard_key_used[ id ] 		 = false
	g_longmessages_count[ id ] 		 = 0
	g_nameguard_menu_displayed[ id ] = 0
	g_nameguard_name_changes[ id ]	 = 0
	
	if( get_pcvar_num( cvar_nameguard_mode ) )
	{
		if( task_exists( id ) )
			remove_task( id )
			
		set_task( 3.0, "nameguard_check", id )
	}
}

public hook_say( id )
{
	static chatguard_mode, chatguard_repeat_mode
	chatguard_mode = get_pcvar_num( cvar_chatguard_mode )
	chatguard_repeat_mode = get_pcvar_num( cvar_chatguard_repeat_mode )
	
	if( ( chatguard_mode || chatguard_repeat_mode ) && I_can_do_something( id ) )
	{
		static said[ 190 ]
		read_args( said, charsmax( said ) )
		remove_quotes( said )

		if( chatguard_mode )
		{
			static i
			
			for( i = 0; i < sizeof( WHITELIST_MESSAGES ); i ++ )
			{
				if( containi( said, WHITELIST_MESSAGES[ i ] ) != -1 )
					return PLUGIN_CONTINUE
			}
			
			for( i = 0; i < sizeof( BLOCKED_MESSAGES ); i ++ )
			{
				if( containi( said, BLOCKED_MESSAGES[ i ] ) != -1 )
				{
					switch( chatguard_mode )
					{
						case 1: return PLUGIN_HANDLED
						case 2:
						{
							if( !is_user_steam( id ) )
								chatguard_punish_menu( id, said )

							return PLUGIN_HANDLED
						}
					}
				}
			}
		}

		if( chatguard_repeat_mode )
		{
			if( strlen( said ) > get_pcvar_num( cvar_chatguard_repeat_len ) )
			{
				static i
				for( i = 0; i < MAX_LONGMESSAGES; i ++ )
				{
					if( equal( g_spam_messages[ id ][ i ], said ) )
					{
						if( chatguard_repeat_mode == 2 )
						{
							static file[ 256 ], log[ 128 ], name[ 32 ], authid[ 35 ], ip[ 23 ], ymd[ 3 ] 
							
							get_user_name( id, name, charsmax( name ) )
							get_user_authid( id, authid, charsmax( authid ) )
							get_user_ip( id, ip, charsmax( ip ), 1 )
							date( ymd[ 0 ], ymd[ 1 ], ymd[ 2 ] )
							
							format( log, charsmax( log ), "%s: %s (AuthID:[%s], IP:[%s])", name, said , authid, ip )
							format( file, charsmax( file ), "%s/yet_another_spamguard/logs/LONGMSGS%d%d%d.txt", g_configs_dir, ymd[ 0 ], ymd[ 1 ], ymd[ 2 ] )
							
							log_to_file( file, log )
						}
						
						return PLUGIN_HANDLED
					}
				}
				
				if( g_longmessages_count[ id ] == MAX_LONGMESSAGES - 1 )
					g_longmessages_count[ id ] = 0
				
				g_longmessages_count[ id ] ++
				
				g_spam_messages[ id ][ g_longmessages_count[ id ] ] = said
			}
		}
	}
	
	return PLUGIN_CONTINUE
}


public chatguard_punish_menu( id, said[] )
{	
#if defined _fakemeta_included
	set_pdata_int( id, OFFSET_CSMENUCODE, 0 )
#endif
	
	static menu[ 512 ], len, keys, text[ 34 ]
	keys = MENU_KEY_1 + MENU_KEY_2
	
	formatex( text, charsmax( text ), "%s", said )

	len = formatex( menu, charsmax( menu ), "\y%s v%s", PLUGIN, VERSION )
	
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n^n\y(\d^"%s..^"\y)", text )
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n\y%L", id, "YASG_CHATGUARD_DETECTED" )
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n%L", id, "YASG_CHATGUARD_DETECTED2" )

	len += formatex( menu[ len ], charsmax( menu ) - len, "^n^n\w1. %L", id, "YASG_CHATGUARD_YES" )
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n2. %L", id, "YASG_CHATGUARD_NO" )

	if( !g_chatguard_key_used[ id ] )
	{
		len += formatex( menu[ len ], charsmax( menu ) - len, "^n3. %L", id, "YASG_CHATGUARD_KEY" )
		keys += MENU_KEY_3
	}

	show_menu( id, keys, menu, _, "chatguard_menu" )
}

public handler_chatguard_menu( id, key )
{
	key ++

	switch( key )
	{
		case 1: reset_defaults_keys( id )
		case 2: client_cmd( id, "disconnect" )
		case 3:
		{
			g_chatguard_key_used[ id ] = true

			yasg_print_color( id, "^1[^4YASG^1] %L", id, "YASG_CHATGUARD_RULES" )
		}
	}
}


public show_nameguard_menu( id, name[] )
{
#if defined _fakemeta_included
	set_pdata_int( id, OFFSET_CSMENUCODE, 0 )
#endif

	static menu[ 512 ], len, keys
	
	keys = MENU_KEY_1 + MENU_KEY_2
	
	len = formatex( menu, charsmax( menu ), "\y%s v%s", PLUGIN, VERSION )
	
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n^n\y(\d^"%s^"\y)", name )
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n\y%L", id, "YASG_NAMEGUARD_DETECTED" )
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n^n^n%L", id, "YASG_NAMEGUARD_DETECTED2" )

	len += formatex( menu[ len ], charsmax( menu ) - len, "^n^n\w1. %L", id, "YASG_NAMEGUARD_YES" )
	len += formatex( menu[ len ], charsmax( menu ) - len, "^n2. %L", id, "YASG_NAMEGUARD_NO" )
	
	if( !g_nameguard_key_used[ id ] )
	{
		len += formatex( menu[ len ], charsmax( menu ) - len, "^n3. %L", id, "YASG_NAMEGUARD_KEY" )
		keys += MENU_KEY_3
	}
	
	show_menu( id, keys, menu, _, "nameguard_menu" )
	
	g_nameguard_menu_displayed[ id ] ++
}

public handler_nameguard_menu( id, key )
{
	key ++

	switch( key )
	{
		case 1: change_name( id )
		case 2: client_cmd( id, "disconnect" )
		case 3:
		{
			g_nameguard_key_used[ id ] = true
			yasg_print_color( id, "^1[^4YASG^1] %L", id, "YASG_NAMEGUARD_RULES" )
		}
	}
}

public nameguard_check( id )
{
	if( !I_can_do_something( id ) || !is_user_connected( id ) )
		return
	
	static name[ 32 ]
	get_user_info( id, "name", name, charsmax( name ) )
	
	if( valid_name( name ) )
		return

	switch( get_pcvar_num( cvar_nameguard_mode ) )
	{
		case 1: kick_user( id, "YASG_KICK_NAMEGUARD" )
		case 2:
		{
			if( g_nameguard_key_used[ id ] )
				kick_user( id, "YASG_KICK_NAMEGUARD" )
			
			else
			{
				if( g_nameguard_menu_displayed[ id ] < 2 )
					show_nameguard_menu( id, name )
				
				else kick_user( id, "YASG_KICK_NAMEGUARD" )
			}
		}
		
		case 3: change_name( id )
	}
}

public change_name( id )
{
	if( !is_user_connected( id ) )
			return
	
	static cvar_name[ 32 ]
	get_pcvar_string( cvar_nameguard_name, cvar_name, charsmax( cvar_name ) ) 
	set_msg_block( g_msg_saytext, BLOCK_ONCE )
	g_setclientkeyvalue_block = true
	set_user_info( id, "name", cvar_name )

	yasg_print_color( id, "^1[^4YASG^1] %L", id, "YASG_NAMEGUARD_NAMECHANGED", cvar_name )
}

public kick_user( id, ml_reason[] )
{
	if( !is_user_connected( id ) )
			return
	
	server_cmd( "kick #%d ^"[YASG] %L^"", get_user_userid( id ), id, ml_reason )
}

public reset_defaults_keys( id )
{
	client_cmd( id, "unbindall" )
	client_cmd( id, "bind ^"TAB^" ^"+showscores^"" )
	client_cmd( id, "bind ^"ENTER^" ^"+attack^"" )
	client_cmd( id, "bind ^"ESCAPE^" ^"escape^"" )
	client_cmd( id, "bind ^"SPACE^" ^"+jump^"" )
	client_cmd( id, "bind ^"'^" ^"+moveup^"" )
	client_cmd( id, "bind ^"+^" ^"sizeup^"" )
	client_cmd( id, "bind ^",^" ^"buyammo1^"" )
	client_cmd( id, "bind ^"-^" ^"sizedown^"" )
	client_cmd( id, "bind ^".^" ^"buyammo2^"" )
	client_cmd( id, "bind ^"/^" ^"+movedown^"" )
	client_cmd( id, "bind ^"0^" ^"slot10^"" )
	client_cmd( id, "bind ^"1^" ^"slot1^"" )
	client_cmd( id, "bind ^"2^" ^"slot2^"" )
	client_cmd( id, "bind ^"3^" ^"slot3^"" )
	client_cmd( id, "bind ^"4^" ^"slot4^"" )
	client_cmd( id, "bind ^"5^" ^"slot5^"" )
	client_cmd( id, "bind ^"6^" ^"slot6^"" )
	client_cmd( id, "bind ^"7^" ^"slot7^"" )
	client_cmd( id, "bind ^"8^" ^"slot8^"" )
	client_cmd( id, "bind ^"9^" ^"slot9^"" )
	client_cmd( id, "bind ^";^" ^"+mlook^"" )
	client_cmd( id, "bind ^"=^" ^"sizeup^"" )
	client_cmd( id, "bind ^"a^" ^"+moveleft^"" )
	client_cmd( id, "bind ^"b^" ^"buy^"" )
	client_cmd( id, "bind ^"c^" ^"radio3^"" )
	client_cmd( id, "bind ^"d^" ^"+moveright^"" )
	client_cmd( id, "bind ^"e^" ^"+use^"" )
	client_cmd( id, "bind ^"f^" ^"impulse 100^"" )
	client_cmd( id, "bind ^"g^" ^"drop^"" )
	client_cmd( id, "bind ^"h^" ^"+commandmenu^"" )
	client_cmd( id, "bind ^"i^" ^"showbriefing^"" )
	client_cmd( id, "bind ^"j^" ^"cheer^"" )
	client_cmd( id, "bind ^"k^" ^"+voicerecord^"" )
	client_cmd( id, "bind ^"m^" ^"chooseteam^"" )
	client_cmd( id, "bind ^"n^" ^"nightvision^"" )
	client_cmd( id, "bind ^"o^" ^"buyequip^"" )
	client_cmd( id, "bind ^"q^" ^"lastinv^"" )
	client_cmd( id, "bind ^"r^" ^"+reload^"" )
	client_cmd( id, "bind ^"s^" ^"+back^"" )
	client_cmd( id, "bind ^"t^" ^"impulse 201^"" )
	client_cmd( id, "bind ^"u^" ^"messagemode2^"" )
	client_cmd( id, "bind ^"w^" ^"+forward^"" )
	client_cmd( id, "bind ^"x^" ^"radio2^"" )
	client_cmd( id, "bind ^"y^" ^"messagemode^"" )
	client_cmd( id, "bind ^"z^" ^"radio1^"" )
	client_cmd( id, "bind ^"[^" ^"invprev^"" )
	client_cmd( id, "bind ^"]^" ^"invnext^"" )
	client_cmd( id, "bind ^"`^" ^"toggleconsole^"" )
	client_cmd( id, "bind ^"~^" ^"toggleconsole^"" )
	client_cmd( id, "bind ^"UPARROW^" ^"+forward^"" )
	client_cmd( id, "bind ^"DOWNARROW^" ^"+back^"" )
	client_cmd( id, "bind ^"LEFTARROW^" ^"+left^"" )
	client_cmd( id, "bind ^"RIGHTARROW^" ^"+right^"" )
	client_cmd( id, "bind ^"ALT^" ^"+strafe^"" )
	client_cmd( id, "bind ^"CTRL^" ^"+duck^"" )
	client_cmd( id, "bind ^"SHIFT^" ^"+speed^"" )
	client_cmd( id, "bind ^"F1^" ^"autobuy^"" )
	client_cmd( id, "bind ^"F2^" ^"rebuy^"" )
	client_cmd( id, "bind ^"F5^" ^"snapshot^"" )
	client_cmd( id, "bind ^"F6^" ^"save quick^"" )
	client_cmd( id, "bind ^"F7^" ^"load quick^"" )
	client_cmd( id, "bind ^"F10^" ^"quit prompt^"" )
	client_cmd( id, "bind ^"INS^" ^"+klook^"" )
	client_cmd( id, "bind ^"PGDN^" ^"+lookdown^"" )
	client_cmd( id, "bind ^"PGUP^" ^"+lookup^"" )
	client_cmd( id, "bind ^"END^" ^"centerview^"" )
	client_cmd( id, "bind ^"MWHEELDOWN^" ^"invnext^"" )
	client_cmd( id, "bind ^"MWHEELUP^" ^"invprev^"" )
	client_cmd( id, "bind ^"MOUSE1^" ^"+attack^"" )
	client_cmd( id, "bind ^"MOUSE2^" ^"+attack2^"" )
	client_cmd( id, "bind ^"PAUSE^" ^"pause^"" )
}

stock bool:valid_name( const username[] )
{	
	static i, name[ 32 ], ret, error[ 128 ], Regex:regex_handle
	
	formatex( name, charsmax( name ), "%s", username )

	for( i = 0; i < sizeof( WHITELIST_NAMES ); i ++ )
	{
		if( containi( name, WHITELIST_NAMES[ i ] ) != -1 )
			return true
	}
	
	for( i = 0; i < sizeof( BLOCKED_NAMES ); i ++ )
	{
		if( containi( name, BLOCKED_NAMES[ i ] ) != -1 )
			return false
	}
	
#if AMXX_VERSION_NUM < 183
	static len
	len = strlen( name )
	
	for( i = 0; i < len; i ++ )
	{
		if( name[ i ] & 1<<31 )
			name[ i ] &= 0xFF
	}
	
	for( i = 0; i < sizeof( g_cyrillic ); i ++ )
		replace_all( name, charsmax( name ), g_cyrillic[ i ], "1" )
	
	regex_handle = regex_compile( g_regex_pattern, ret, error, charsmax( error ) )
#else
	regex_handle = regex_compile_ex( g_regex_pattern, PCRE_UTF8, error, charsmax( error ), ret )
#endif

	if( regex_handle != REGEX_PATTERN_FAIL )
	{
		switch( regex_match_c( name, regex_handle, ret ) )
		{
			case REGEX_MATCH_FAIL: log_to_file( "[YASG] REGEX MATCH FAILED FOR %s", name )
			case REGEX_NO_MATCH: return false
		}
		
		regex_free( regex_handle )
	}
	
	return true
}


stock bool:I_can_do_something( id )
{
	if( is_user_bot( id ) )
		return false
	
	if( is_user_hltv( id ) ) 
		return false
	
	static flags[ 23 ]
	get_pcvar_string( cvar_immunity_flag, flags, charsmax( flags ) )
	
	if( get_user_flags( id ) & read_flags( flags ) )
		return false
	
	return true
}

stock bool:is_user_steam( id ) // Sh0oter
{
	static dp_pointer
	
	if( dp_pointer || ( dp_pointer = get_cvar_pointer( "dp_r_id_provider" ) ) )
	{
		server_cmd( "dp_clientinfo %d", id )
		server_exec()
		return ( get_pcvar_num( dp_pointer ) == 2 ) ? true : false
	}
	
	return false
}

stock yasg_print_color( const id, const input[], any:... )
{
#if AMXX_VERSION_NUM < 183
	static msg[ 190 ], players[ 32 ], num
	
	vformat( msg, charsmax( msg ), input, 3 )
	num = 1
    
	replace_all( msg, charsmax( msg ), "!g", "^4" ) // Green Color
	replace_all( msg, charsmax( msg ), "!n", "^1" ) // Default Color
	replace_all( msg, charsmax( msg ), "!t", "^3" ) // Team Color
    
	if( id ) players[ 0 ] = id; else get_players( players, num, "ch" )
	{
		static i
		for( i = 0; i < num; i ++ )
		{
			if( is_user_connected( players[ i ] ) )
			{
				message_begin( MSG_ONE_UNRELIABLE, get_user_msgid( "SayText" ), _, players[ i ] )
				write_byte( players[ i ] )
				write_string( msg )
				message_end()
			}
		}
	}
#else
	client_print_color( id, print_team_default, input )
#endif
	return 0
}